;
;	Szubrutinok KEP fjl megjelentshez VT-DOS-ra
;

;
;	Konstansok KEP fjl fejlchez
;
KEPHEAD_ID	.equ	0		; "KEP" azonost szveg kezdete a fejlcben
KEPHEAD_TYPE	.equ	3		; kp tpusbjt helye a fejlcben
KEPHEAD_PAL	.equ	4		; paletta adatok kezdete a fejlcben
KEPHEAD_XSIZE	.equ	8		; X irny kiterjeds helye a fejlcben
KEPHEAD_YSIZE	.equ	10		; Y irny kiterjeds helye a fejlcben

; Formzsi s tmrtsi kdok (3..2 bit a tpusbjtban)

KEPTYPE_NFORM	.equ	000h		; nem formzott kp tpuskdja (csak 8 bjtos a fejlc)
KEPTYPE_FORM	.equ	008h		; formzott kp tpuskdja
KEPTYPE_RLE	.equ	004h		; RLE tmrtett formzott kp tpuskdja
KEPTYPE_FMASK	.equ	0FCh		; maszk a formtumkdhoz

; Sznkdok (1..0 bit a tpusbjtban)

KEPTYPE_2COL	.equ	000h		; 2-szn kp tpuskdja
KEPTYPE_4COL	.equ	001h		; 4-szn kp tpuskdja
KEPTYPE_16COL	.equ	002h		; 16-szn kp tpuskdja
KEPTYPE_COLMASK	.equ	003h		; maszk a sznkdokhoz


;
; 	Kp kirajzolsa a kpernyre
;	in:  DE - adatok hossza, ha formzatlan a kp (nincs fejlc) 
;	     HL - kpadatok kezdete
;	out: -
;
kirajz:	ld	a,(hl)			; fejlc ellenrzse
	cp	'K'
	ret	nz
	inc	hl
	dec	de
	ld	a,(hl)
	cp	'E'
	ret	nz
	inc	hl
	dec	de
	ld	a,(hl)
	cp	'P'
	ret	nz
	inc	hl
	dec	de
	ld	a,(hl)			; kp tpusa
	and	KEPTYPE_COLMASK
	push	de
	ld	c,a
	call	kepmod			; grafikus md belltsa: 0-ktszn  1-ngy  2-tizenhat
	pop	de
kiraj2:	ld	a,(hl)			; kp tpusa
	inc	hl
	dec	de
	cp	KEPTYPE_NFORM + KEPTYPE_16COL
	jr	z,kepre0		; ugrs, ha formzatlan s tmrtetlen 16 szn kp
	ld	b,004h			; B= belltand paletta-regiszterek szma (4)
	ld	c,05Fh			; C= paletta-regiszterek I/O cme -1
pal:	inc	c			; paletta belltsa
	dec	de			; kirand hosszt is cskkenti
	outi				; regiszter lltsa, B=B-1
	jr	nz,pal
	ld	c,a			; C= kp tpusa
	and	KEPTYPE_FMASK
	jr	z,kepre0		; mehet, ha csak sima formzatlan, tmrtetlen kp
	ld	de,0FFFFh		; a formzott kpeket a kperny kzepre rajzolja ki
	cp	KEPTYPE_FORM
	jr	z,kepre1		; formzott, tmrtetlen kp (A reg.= 8)
	jp	kepre2			; formzott, tmrtett	kp   (A reg.= 4)


;
;	Tmrtetlen, formzatlan kp megjelentse
;	in:  DE - kpadatok hossza
;	     HL - kpadatok kezdete
;	out: -
;
kepre0:	ld	b,d
	ld	c,e
	ld	de,08000h
	di
	ld	a,050h			; 50h = U0, U1, VID, SYS
	out	(002h),a		; memrialapozs belltsa
	ldir				; teljes kppuffer tmsolsa a videomemriba
	jp	kirveg			; ugrs a befejezsre


;
;	Tmrtetlen, formzott kp megjelentse
;	in:   C - kp tpusa (0- 2 szn  1- 4 szn  2- 16 szn)
;	     DE - megjelents kezd kpernycme, ha DE= 0FFFFh akkor kzpre igazt
;	     HL - kp+8 pozcira mutat a fejlcben
;	out: -
;
kepre1:	call	keppoz			; megjelentsi paramterek kiszmtsa
	di
	ld	a,050h			; 50h = U0, U1, VID, SYS
	out	(002h),a		; memrialapozs belltsa
	ld	a,b			; A reg.= sorok szma
	or	a
	jp	z,kirveg		; ugrs a befejezsre, ha nulla a sorok szma
	ld	a,(lbmask)
	ld	c,a			; C= a sor utols bjtjnak maszkja
kep1r:	push	de			; kpernysor kezdete a verembe
	push	hl			; adatok kezdete a verembe
	push	bc			; szmll s maszk a verembe
	ld	a,(dspln)
	dec	a			; a sor utols bjtjt mg nem rja ki
	jr	z,kep1s			; ugrs, ha csak 1 bjtbl ll a sor
	ld	c,a
	ld	b,000h			; kirand sorhossz BC-be
	ldir
kep1s:	pop	bc			; B=sorszmll  C= maszk az utols bjthoz
	ld	a,(hl)
	and	c
	ld	(de),a
	ld	hl,(scanln)		; forrs adatok kvetkez sornak szmtsa
	pop	de
	add	hl,de
	ex	(sp),hl			; forrscm verembe, clcmet elveszi
	ld	de,64			; egy kpernysor 64 bjt
	add	hl,de
	ex	de,hl			; DE=kvetkez sor eleje
	pop	hl			; HL=forrs kvetkez sora
	djnz	kep1r
	jp	kirveg			; ugrs a befejezsre


;
;	RLE tmrts kp megjelentse
;	in:   C - kp tpusa (0- 2 szn  1- 4 szn  2- 16 szn)
;	     DE - megjelents kezd kpernycme, ha DE= 0FFFFh akkor kzpre igazt
;	     HL - kp+8 pozcira mutat a fejlcben
;	out: -
;
kepre2:	call	keppoz			; megjelentsi paramterek kiszmtsa
	di
	ld	a,050h			; 50h = U0, U1, VID, SYS
	out	(002h),a		; memrialapozs belltsa
	ld	a,b			; A reg.= sorok szma
	or	a
	jp	z,kirveg		; ugrs a befejezsre, ha nulla a sorok szma
	exx
	ld	b,a			; B'= sorok szma
	ld	a,(lbmask)
	ld	c,a			; C'= az utols kpbjt maszkja
	exx
	ld	b,000h			; B= 0 -> count/data megklnbztet maszk
kep20:	push	de			; DE= sor kezdete
	ld	a,(dspln)
	ld	c,a			; C= az aktulis sorban htralev bjtok szma
kep21:	ld	a,(hl)
	and	0C0h
	cp	b			; sszehasonlts a maszkkal
	jp	nz,kep22		; ugrs, ha a bjt adat
	xor	(hl)			; szmll A reg.-be s a fels 2 bit nullzsa
	inc	hl
	dec	a			; count=1 ?
	jr	nz,kep23		; ugrs, ha nem
	ld	a,b
	add	a,040h
	ld	b,a			; maszk=maszk+64
kep22:	ld	a,(hl)			; A reg.= adat
	inc	hl
	dec	c
	jr	z,kep26			; ugrs, ha az utols bjt a sorban
	ld	(de),a			; adat a kpre
	inc	de
	jp	kep21			; kvetkez RLE adat feldolgozsa	
;
kep23:	push	bc			; maszk mentse
	ld	b,a			; B= count-1
	cpl				; A reg.= -1 * (A reg.+1) = -count
	add	a,c			; htralv bjtok cskkentse, ZF=1 ha vge a sornak
	ld	c,a			; (a kdolsnak soronknt kell trtnnie !!!)
	ld	a,(hl)			; A reg.= adat
	inc	hl
kep24:	ld	(de),a			; count-1 darab kpbjt letrolsa
	inc	de
	djnz	kep24
	jr	z,kep25			; ugrs, ha elrte a sor vgt (c=0)
	ld	(de),a			; utols kpbjt letrolsa
	inc	de
	pop	af			; maszk vissza
	ld	b,a
	jp	kep21			; kvetkez RLE adat feldolgozsa
;
kep25:	pop	bc			; maszk vissza
kep26:	exx
	and	c			; utols kpbjt maszkolsa
	dec	b			; sorszmll cskkentse
	exx
	ld	(de),a
	pop	de			; DE=sor kezdete
	jr	z,kirveg		; ugrs a befejezsre, ha az sszes sor kirajzolva
	ld	a,64
	add	a,e
	ld	e,a
	jr	nc,kep20
	inc	d
	jp	kep20			; soronknt kell kdolni!!!
;
kirveg:	ld	a,(003Bh)		; eredeti lapozs vissza
	out	(002h),a
	ei
	ret	


;
;
;	A kp megjelentsi paramtereinek kiszmtsa a fejlcbjtok alapjn
;	in:   C - kp tpusa
;	     DE - megjelents kezd kpernycme, ha DE= 0FFFFh akkor kzpre igazt
;	     HL - kp+8 pozcira mutat a fejlcben
;	out:  B - sorok szma
;	     DE - kpernycm
;	     HL - megjelentend adatok kezdete
;
keppoz:	push	de			; kvnt megjelentsi kpernycm mentse
	ld	a,c			; A reg.= kp tpusa
	ld	e,(hl)
	inc	hl
	ld	d,(hl)			; DE= X kiterjeds
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)			; BC= Y kiterjeds (sorok szma)
	ld	(rows),bc
	ld	bc,0005h
	add	hl,bc
	push	hl			; adatok kezdcme a verembe
	ex	de,hl			; HL= X kiterjeds
	ld	c,b			; C= 0 - hibs kp esetn ez lesz a sorok szma
	and	KEPTYPE_COLMASK
	ld	b,a			; B= sznek szma (0- 2szn  1- 4szn  2- 16szn)
	ld	a,l			; A reg.= X kiterjeds als bjtja
	jr	nz,kep11		; ugrs, ha nem 2-szn kp
	ld	c,007h			; BC= bjtonknti kppontok szma - 1
	add	hl,bc			; X kiterjeds felfel kerektse
	srl	h
	rr	l
	srl	h
	rr	l
	srl	h
	rr	l			; HL=HL/8 -> X kiterjeds bjtokban
	ld	de,gr2mask
	jp	kep13
;
kep11:	dec	b
	jr	nz,kep12		; ugrs, ha nem 4-szn kp
	ld	c,003h
	add	hl,bc			; felfel kerekts
	srl	h
	rr	l
	srl	h
	rr	l			; HL=HL/4
	ld	de,gr4mask
	jp	kep13
;
kep12:	dec	b
	jp	nz,kep16		; ugrs, ha nem 16-szn kp (hibs kp)
	ld	c,001h
	add	hl,bc
	srl	h
	rr	l			; HL=HL/2
	ld	de,gr16msk
kep13:	ld	(scanln),hl		; egy sor hossza bjtokban, felfel kerektve
	ex	de,hl			; DE= scanln  HL= maszktblzat cme
	and	c			; A reg.= (X kiterjeds) mod (bjtonknti kppontok szma)
	ld	c,a
	add	hl,bc			; utols bjt maszkjnak kikeresse, majd trolsa
	ld	a,(hl)
	ld	(lbmask),a
	ld	hl,64			; X kiterjeds ellenrzse
	or	a
	sbc	hl,de			; scanln > 64 ?
	jr	nc,kep14
	ld	e,64			; E= megjelentend sorhossz bjtban
	ld	l,000h			; L= klnbsg a teljes sorhossztl
kep14:	ld	a,e
	ld	(dspln),a		; megjelentend sorhossz trolsa
	ld	e,l
	srl	e			; E= (64-dspln)/2
	ld	d,000h			; DE= X irny eltols kzpre igaztshoz
	or	a			; Y kiterjeds ellenrzse
	ld	bc,(rows)		; BC= sorok szma
	ld	hl,240			; jelenleg max.240 lehet
	sbc	hl,bc			; sszehasonlts, s HL-ben a klnbsg
	jr	nc,kep15		; ugrs, ha Y<=240
	ld	c,240			; C= sorok szma
	ld	hl,0000h
kep15:	res	0,l			; kp kzpre igaztsa, 0.bit trlse a sor-klnbsgben
	sla	l
	rl	h
	sla	l
	rl	h
	sla	l
	rl	h
	sla	l
	rl	h
	sla	l
	rl	h			; HL= HL*32=HL/2*64 -> ennyi Y irnyban az eltols
	add	hl,de			; X irny eltols hozzadsa
	ld	de,08000h		; video memria kezdete
	add	hl,de
	ex	de,hl			; DE= kzpre igaztott kpernycm
kep16:	ld	a,c			; sorok szma A reg.-be
	pop	bc			; BC= pixel adatok kezdete
	pop	hl			; HL= belpskor kapott kezd kpernycm
	push	af
	ld	a,l
	and	h
	inc	a
	jr	z,kep17			; ugrs, ha kzpre kellett igaztani
	ex	de,hl			; egybknt a megadott cmet adja vissza
kep17:	ld	l,c
	ld	h,b			; HL= pixel adatok kezdete
	pop	bc			; B = sorok szma
	ret


;
;
;	Videmd belltsa s a kperny trlse
;	in:   C - videmd
;	out: HL - megrzdik
;
kepmod:	push	hl
	push	bc			; videmd a verembe
	ld	a,(0003Bh)		; eredeti lapozs A reg.-be
	push	af			; lapozs mentse a verembe
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	(0003Bh),a		; j felhasznli lapozs belltsa
	out	(002h),a		; lapozs a porton
	ld	hl,08000h		; kperny trlse
	ld	de,08001h
	ld	a,000h			; A reg.= kitltbjt
	ld	(hl),a
	ld	bc,03BFFh
	ldir
	ld	hl,defpal		; HL a belltand alap palettra mutat
	ld	c,060h			; C= paletta-regiszterek I/O cme
	outi				; palettaregiszterek belltsa
	inc	c
	outi
	inc	c
	outi
	inc	c
	outi
	pop	af			; felhasznli lapozs vissza
	ld	(0003Bh),a
	out	(002h),a
	pop	bc
	ld	a,c
	out	(006h),a		; zemmd belltsa (+hang amplitd nullzsa)
	pop	hl
	ret


;
defpal	.db	000h, 050h, 044h, 041h	; palettaregiszterek alaprtkei
;
gr2mask	.db	0FFh,080h,0C0h,0E0h,0F0h,0F8h,0FCh,0FEh	; utols bjtok maszkja 2 sznnl
gr4mask	.db	0FFh,088h,0CCh,0EEh			; utols bjtok maszkja 4 sznnl
gr16msk	.db	0FFh,0AAh				; utols bjtok maszkja 16 sznnl

;
rows	.db	0,0			; kp sorainak szma
scanln	.db	0,0			; egy kpsor bjtjainak szma
dspln	.db	0			; kpernyn egy sor bjtjainak szma
lbmask	.db	0			; az utols bjt maszkja
;

.end

