;
;-----------------------------------------------------------------
;
;	ltalnos segdrutinok
;
;-----------------------------------------------------------------
;


;
;
;	32-bites oszts
;	in:  BC - osztand fels sz
;	     DE - oszt
;	     HL - osztand als sz
;	out: BC - eredmny fels sz
;	     DE - megrzdik
;	     HL - eredmny als sz
;
ut_div32:
	push	de			; oszt a verembe
	push	hl			; osztand als szava a verembe
	call	ut_div			; fels sz osztsa
	ex	de,hl			; maradk DE-be
	ld	h,b			; eredmny HL-be
	ld	l,c
	pop	bc			; osztand als szava BC-be
	ex	(sp),hl			; eredmny fels szava a verembe, oszt HL-be
	ex	de,hl			; oszt DE-be, maradk HL-be
	call	ut_div0			; oszts folytatsa az als szval
	ld	h,b			; eredmny als szava HL-be
	ld	l,c	
	pop	bc			; eredmny fels szava BC-be
	ret


;
;
;	16-bites oszts
;	in:  BC - osztand
;	     DE - oszt
;	out: BC - eredmny
;	     DE - megrzdik
;	     HL - maradk
;
ut_div:	xor	a			; A reg.= 000h  CY= 0
	ld	h,a			; HL= munkaregiszter (0000h)
	ld	l,a
ut_div0:ld	a,010h			; A reg.= 16 bites mvelet lesz
ut_div1:ccf				; CY invertlsa
ut_div2:rl	c			; eredmny bit belptetse
	rl	b			; osztand bit kilptetse CY-be
	dec	a			; ciklusszmll cskkentse
	ret	m			; visszatrs, ha A reg. kisebb lett nullnl
	adc	hl,hl			; osztand kvetkez bitjnek belptetse HL-be
	jr	c,ut_div3		; 32 bites oszts esetn itt tlcsorduls lehet, ezt kln kell kezelni
	sbc	hl,de			; oszt kivonsa
	jr	nc,ut_div1		; ugrs, ha megvan az osztandban
	add	hl,de			; egybknt a kivons visszalltsa
	or	a			; CY= 0
	jr	ut_div2			; folytats a kvetkez bittel
;
ut_div3:or	a			; CY= 0
	sbc	hl,de
	jr	ut_div2			; itt CY= 1 -nek kell lennie (minden esetben?)
	

;
;
;	32-bites szm osztsa 8-bites szmmal
;	in:   C - oszt
;	     DE - osztand fels sz
;	     HL - osztand als sz
;	out:  A - maradk
;	      C - megrzdik
;	     DE - eredmny fels sz
;	     HL - eredmny als sz
;
ut_div32_8:
	xor	a
	ld	b,32			; 32 bites oszts lesz
ut_div4:add	hl,hl
	rl	e
	rl	d
	rla				; legfels bit belptetse A reg.-be
	cp	c
	jr	c,ut_div5
	sub	c
	inc	l			; eredmny szmolsa L-ben
ut_div5:djnz	ut_div4			; ismtls mind a 32 bitre
	ret


;
;
;	48-bites szm osztsa 8-bites szmmal
;	in:   C - oszt
;	     DE - osztand fels sz
;	     HL - osztand kzps sz
;	     IX - osztand als sz
;	out:  A - maradk
;	      C - megrzdik
;	     DE - eredmny fels sz
;	     HL - eredmny kzps sz
;	     IX - eredmny als sz
;
ut_div48:
	xor	a
	ld	b,48			; 48 bites oszts lesz
ut_div6:add	ix,ix
	adc	hl,hl
	rl	e
	rl	d
	rla				; legfels bit belptetse A reg.-be
	cp	c
	jr	c,ut_div7
	sub	c
	inc	ix			; eredmny szmolsa IX-ben
ut_div7:djnz	ut_div6			; ismtls mind a 48 bitre
	ret


;
;
;	16-bites szorzs
;	in:  BC - szorz
;	     DE - szorzand
;	out: BC - megrzdik
;	     DE - eredmny als szava
;	     HL - eredmny fels szava
;
ut_mul:	push	bc
	ld	a,b			; szorz fels bjtja A reg.-be
	ld	hl,00000h		; HL-ben lesz az eredmny als szava
	ld	b,010h			; B= 16-bites szorzs lesz
ut_mul0:add	hl,hl			; eredmny balra lptetse
	rl	c			; A reg.-ben s C-ben lv szorz balra lptetse
	rla
	jr	nc,ut_mul1		; ugrs, ha 0 a kilp bit
	add	hl,de			; szorzand hozzadsa az eredmnyhez
	jr	nc,ut_mul1		; ugrs, ha nincs tlcsorduls
	inc	c			; tlcsordulsok hozzadsa C-hez
	jr	nz,ut_mul1		; ugrs, ha C mg nem csordult tl
	inc	a			; tovbbi tvitel hozzadsa A reg.-hez
ut_mul1:djnz	ut_mul0			; ismtls mind a 16 bitre
	ex	de,hl			; eredmny als szava DE-be
	ld	l,c			; eredmny fels szava HL-be
	ld	h,a
	pop	bc			; BC helyrelltsa
	ret


;
;
;	BIN->BCD->ASCII konvertls
;	megj.: mindig 10 karaktert r a pufferbe, a bevezet 0-kat szkzzel helyettesti
;
;	in:  HL - 32 bites binris szm fels bjtjnak cme
;	     DE - ASCII szm els karakternek cme
;	out: DE - a szm utols karaktere utni cmre mutat
;
ut_ascc:push	de			; ASCII szm puffer-cmnek mentse
	xor	a
	ld	de,bcdMSB
	ld	b,5			; B=BCD szm hossza bjtban (5=>10 szmjegy)
ascc0:	ld	(de),a			; BCD szm nullzsa
	inc	de
	djnz	ascc0
	ld	b,04			; binris szm hossza bjtban
	ld	c,08			; 8-szor lpteti balra HL ltal mutatott bjtot
ascc1:	push	bc
ascc2:	ld	de,bcdLSB		; DE=BCD szm als bjtja
	ld	b,5			; B=BCD szm hossza bjtban
	rlc	(hl)
ascc3:	ld	a,(de)
	adc	a,a
	daa
	ld	(de),a
	dec	de
	djnz	ascc3
	dec	c
	jr	nz,ascc2
	dec	hl
	pop	bc
	djnz	ascc1
	ld	de,bcdMSB		; BCD konvertlsa ASCII-ba, DE=BCD fels bjtja
	pop	hl			; HL=ASCII szm els karaktere
	ld	b,5			; B=BCD szm hossza bjtban
ascc4:	ld	a,(de)			; a kezd 0-k helyettestse SPACE-el
	and	0F0h
	jr	nz,ascc5
	ld	(hl),20h		; SPACE bersa
	inc	hl
	ld	a,(de)
	and	0Fh
	jr	nz,ascc6
	ld	(hl),20h		; SPACE bersa
	inc	hl
	inc	de
	djnz	ascc4
	dec	hl
	ld	(hl),30h		; ha a szm=0, akkor az utols bjtra '0' kerl
	inc	hl
	ex	de,hl
	ret
;
ascc5:	ld	a,(de)			; hasznos szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
ascc6:	ld	a,(de)
	and	0Fh
	add	a,30h
	ld	(hl),a
	inc	hl
	inc	de
	djnz	ascc5
	ex	de,hl
	ret


;
;
;	Egybjtos BIN szm konvertlsa 2-szmjegy DEC ASCII-ba
;	in:   A - binris szm
;	     DE - hova
;	out: DE - a kirt szm utni cm
;
ut_bcon:ld	c,a			; C-bl lpnek ki a bitek
	xor	a			; A-ban lesz a kt helyirtk BCD szm
	ld	b,008h			; 8-szor lpteti balra
bcon0:	rlc	c
	adc	a,a
	daa
	djnz	bcon0
bcon1:	ld	b,a			; BCD szmjegyek konvertlsa ASCII-ba
	rra
	rra
	rra
	rra
	and	00Fh
	add	a,030h
	ld	(de),a
	inc	de
	ld	a,b
	and	00Fh
	add	a,030h
	ld	(de),a
	inc	de
	ret

.end
